## webapi 4.2.0

=== Makefile ===
PROJECT = webapi
VERSION = 4.2.0

PACKAGE = $(shell dpkg-parsechangelog -S Source)_$(shell dpkg-parsechangelog -S Version)
CHANGES = ../$(PACKAGE)_$(shell dpkg-architecture -qDEB_HOST_ARCH).changes

PREFIX = $(if $(DEB_BUILD_ARCH),$(DESTDIR)/usr,/usr/machine/rz)

BINDIR = $(PREFIX)/bin
PERLDIR = $(if $(DEB_BUILD_ARCH),$(DESTDIR)/usr/share,/usr/machine/lib)/perl5
SUPER = NET
MANDIR = $(if $(DEB_BUILD_ARCH),$(DESTDIR)/usr/share,/usr/segment)/man/man3

LIBEXECDIR = /usr/local/libexec
#HOSTS = scc-big-ip-01.scc.kit.edu scc-big-ip-02.scc.kit.edu
#HOSTS = scc-big-ip-03.scc.kit.edu scc-big-ip-04.scc.kit.edu
DEBHOSTS = web-master.scc.kit.edu web1.scc.kit.edu web2.scc.kit.edu web3.scc.kit.edu web4.scc.kit.edu web5.scc.kit.edu lists-mgmt-bookworm.scc.kit.edu lists-kit-02.scc.kit.edu lists-dfn-02.scc.kit.edu lists-test-bookworm.scc.kit.edu ftp.scc.kit.edu proxy2.scc.kit.edu andy.scc.kit.edu # proxy1.scc.kit.edu

SYMPA = lists4.scc.kit.edu

SCRIPTS = fqdn a ptr txt cname soa ns
PERL_MODULES = $(SUPER)/WebAPI.pm
MANPAGE = WebAPI.3pm

#INSTALL = /usr/machine/bin/install -c -p
INSTALL_DATA = $(INSTALL) -m 644
INSTALL_SCRIPT = $(INSTALL) -m 755

.PHONY: all install f5 sympa clean dist deb

all: $(SCRIPTS) $(PERL_MODULES) $(MANPAGE)
	# Fix version number in perl modules
	perl -pi -MCwd -e 'BEGIN{$$version=cwd=~s/.*-//r}s/^(#.*\sv)\S+(\s+\(c\))/$$1$$version$$2/;s/^(our\s+\$$VERSION\s*=\s*")[v\d._]+(";)/$$1v$$version$$2/' $(PERL_MODULES)

$(MANPAGE): $(SUPER)/WebAPI.pm
	pod2man -s 3pm $< >$@

install: all
	test -d $(BINDIR) || mkdir -p $(BINDIR)
	#$(INSTALL_SCRIPT) $(SCRIPTS) $(BINDIR)
	# F5 has no perldiag.pod
	set -x; for file in $(SCRIPTS); do sed 's/^use diagnostics;$$/#&/' "$${file}" >"$(BINDIR)/$${file}" && chmod 755 "$(BINDIR)/$${file}"; done
	test -d $(PERLDIR)/$(SUPER) || mkdir -p $(PERLDIR)/$(SUPER)
	$(INSTALL_SCRIPT) $(PERL_MODULES) $(PERLDIR)/$(SUPER)
	test -d $(MANDIR) || mkdir -p $(MANDIR)
	$(INSTALL_DATA) $(MANPAGE) $(MANDIR)/$(SUPER)::$(MANPAGE)
	printenv >/tmp/install

f5: all
	ssh=/usr/bin/ssh; test -x $${ssh} || ssh=ssh2; \
	scp=/usr/bin/scp; test -x $${scp} || scp=scp2; \
	for host in $(HOSTS); do \
		$${ssh} -x -a -k root@$${host} 'mount -o rw,remount /usr'; \
		$${ssh} -x -a -k root@$${host} 'mkdir -p $(LIBEXECDIR)/$(SUPER)'; \
		$${scp} -p $(PERL_MODULES) root@$${host}:$(LIBEXECDIR)/$(SUPER); \
		$${ssh} -x -a -k root@$${host} 'mount -o ro,remount /usr'; \
		tar cCf $$HOME - .access/smime/NET-WebAPI | $${ssh} -x -a -k $${host} 'tar xf -'; \
	done

sympa: all
	ssh=/usr/bin/ssh; test -x $${ssh} || ssh=ssh2; \
	scp=/usr/bin/scp; test -x $${scp} || scp=scp2; \
	for host in $(SYMPA); do \
		tar cCf $$HOME - .access/smime/NET-WebAPI | $${ssh} -x -a -k $${host} 'tar xf -'; \
	done

clean:
	rm -f $(MANPAGE)

dist: clean
	cd ..; 	tar cf - $(PROJECT)-$(VERSION) | bzip2 >$(PROJECT)-$(VERSION).tar.bz2

deb $(CHANGES): $(MAKEFILE_LIST) debian/* debian/*/* $(SCRIPTS) $(PERL_MODULES)
	cme check -strict dpkg
	# While we share directory structure with rzsoft, fix VERSION in Makefile and Homepage in debian/control
	perl -pi -MCwd -e 'BEGIN{$$version=cwd=~s/.*-//r}s/^(VERSION\s*=\s*).*$$/$$1$$version/' Makefile
	perl -pi -MCwd -e 'BEGIN{$$dir=cwd=~s!.*/!!r}s!^(Homepage:.*/)[^/]+/$$!$$1$$dir/!' debian/control
	env LC_ALL=C.UTF-8 dpkg-buildpackage -I -I.old --check-command=lintian --check-option=-i --check-option=-I --check-option=--suppress-tags-from-file=debian/changes/lintian-overrides -tc

dput: $(CHANGES)
	# Assert all debugging uses have been commented
	! egrep '^use (lib|diagnostics)' $(SCRIPTS)
	dput $(CHANGES) && rm -f ../$(PACKAGE)[_.]* || echo "Failure might mean same version is already uploaded; consider dput-remove"

deploy: $(CHANGES)
	for host in $(DEBHOSTS); do \
		echo "*** $${host} ***"; \
		ssh root@$${host} 'dpkg-deb --fsys-tarfile - | tar -C / -x' < ../$$(sed -ne '1s/^\([^ ]*\)  *(\([^)]*\)).*/\1_\2/p' debian/changelog)_all.deb; \
	done
	rm -f ../$(PACKAGE)[_.]*

upgrade:
	for host in $(DEBHOSTS); do \
		echo "*** $${host} ***"; \
		ssh root@$${host} 'apt-get update && env DEBIAN_FRONTEND=noninteractive apt-get -y upgrade'; \
	done

=== debian/changelog ===
webapi (4.2.0) bullseye bookworm trixie forky duke; urgency=medium

  * New backend version

 -- Andreas Ley <andreas.ley@kit.edu>  Mon, 03 Nov 2025 18:09:48 +0100

webapi (3.2.7) buster bullseye bookworm; urgency=medium

  * Fix transaction usage (now array reference manadatory if no options
    specified)
  * Fix internal transaction calls
  * Adapt is_dnsvs for first sub-FQDN found

 -- Andreas Ley <andreas.ley@kit.edu>  Sat, 25 May 2024 17:17:07 +0200

webapi (3.2.6) buster bullseye bookworm; urgency=medium

  * Added options to transaction, implement dict_mode
  * fqdn: Changed --check to --exist (--check legal but deprecated)
  * fqdn: Added --dnsvs option

 -- Andreas Ley <andreas.ley@kit.edu>  Thu, 23 May 2024 10:30:46 +0200

webapi (3.2.5) buster bullseye bookworm; urgency=medium

  * fqdn: Changed -C to -e
  * fqdn: Added -C/--create option

 -- Andreas Ley <andreas.ley@kit.edu>  Tue, 21 May 2024 22:45:38 +0200

webapi (3.2.4) buster bullseye bookworm; urgency=medium

  * Updated WebAPI server name

 -- Andreas Ley <andreas.ley@kit.edu>  Tue, 02 Apr 2024 16:43:39 +0200

webapi (3.2.3) stretch buster bullseye bookworm; urgency=medium

  * Use NetAddr::IP->canon for dns.record calls

 -- Andreas Ley <andreas.ley@kit.edu>  Fri, 02 Dec 2022 00:42:01 +0100

webapi (3.2.2) stretch buster bullseye bookworm; urgency=medium

  * Replaced service by meta

 -- Andreas Ley <andreas.ley@kit.edu>  Thu, 04 Aug 2022 23:14:11 +0200

webapi (3.2.1) stretch buster bullseye bookworm; urgency=medium

  * Replace target_ipaddr_cidr by data for dns/record/list

 -- Andreas Ley <andreas.ley@kit.edu>  Fri, 03 Jun 2022 15:47:33 +0200

webapi (3.2.0) stretch buster bullseye bookworm; urgency=medium

  * New backend version
  * Replaced all 'host' fqdn types by 'domain'

 -- Andreas Ley <andreas.ley@kit.edu>  Mon, 16 May 2022 14:10:52 +0200

webapi (3.0.13) stretch buster bullseye bookworm; urgency=medium

  * Fix is_nonterminal() to return simple perl boolean

 -- Andreas Ley <andreas.ley@kit.edu>  Thu, 03 Mar 2022 22:41:18 +0100

webapi (3.0.12) stretch buster bullseye bookworm; urgency=medium

  * Added is_nonterminal()
  * txt: Upgrade to domain when is_nonterminal fails (instead of is_domain)

 -- Andreas Ley <andreas.ley@kit.edu>  Wed, 23 Feb 2022 05:31:52 +0100

webapi (3.0.11) stretch buster bullseye bookworm; urgency=medium

  * Added is_alias()
  * Changed update_fqdn_type() to literal type
  * cname: Change preexisting FQDN to alias type if not already
  * fqdn: Added --type option

 -- Andreas Ley <andreas.ley@kit.edu>  Fri, 30 Jul 2021 22:07:02 +0200

webapi (3.0.10) stretch buster bullseye bookworm; urgency=medium

  * Add TMPDIR to tempfile in write_config()

 -- Andreas Ley <andreas.ley@kit.edu>  Wed, 07 Apr 2021 14:33:33 +0200

webapi (3.0.9) stretch buster bullseye bookworm; urgency=medium

  * Read NetVS token from ~/.config/netdb_client.ini even if HOME isn't defined
  * Moved module to semantic versioning

 -- Andreas Ley <andreas.ley@kit.edu>  Sat, 03 Apr 2021 02:05:23 +0200

webapi (3.0.8) stretch buster bullseye bookworm; urgency=medium

  * Use Term::Cap only when TERM is definied

 -- Andreas Ley <andreas.ley@kit.edu>  Wed, 31 Mar 2021 07:38:16 +0200

webapi (3.0.7) stretch buster bullseye bookworm; urgency=medium

  * Added write_config()

 -- Andreas Ley <andreas.ley@kit.edu>  Thu, 25 Mar 2021 12:40:15 +0100

webapi (3.0.6) stretch buster bullseye bookworm; urgency=medium

  * create_a(): Check whether an option is defined AND evaluates to true

 -- Andreas Ley <andreas.ley@kit.edu>  Tue, 05 Jan 2021 14:01:07 +0100

webapi (3.0.5) stretch buster bullseye bookworm; urgency=medium

  * Implement token authentication

 -- Andreas Ley <andreas.ley@kit.edu>  Wed, 25 Nov 2020 00:48:04 +0100

webapi (3.0.4) stretch buster bullseye bookworm; urgency=medium

  * create_a(): Use JSON booleans

 -- Andreas Ley <andreas.ley@kit.edu>  Sat, 21 Nov 2020 23:27:44 +0100

webapi (3.0.3) stretch buster bullseye bookworm; urgency=medium

  * fqdn: Added -l and -C option

 -- Andreas Ley <andreas.ley@kit.edu>  Fri, 20 Nov 2020 00:37:57 +0100

webapi (3.0.2) stretch buster bullseye bookworm; urgency=medium

  * txt: Only upgrade to domain when not already domain
  * list_a(): Replace target_ipaddr_cidr request by more performant
    api_fkey_dns_record_target_ipaddr transaction

 -- Andreas Ley <andreas.ley@kit.edu>  Wed, 18 Nov 2020 19:23:10 +0100

webapi (3.0.1) stretch buster bullseye bookworm; urgency=medium

  * Migrate all calls to API 3.0 syntax

 -- Andreas Ley <andreas.ley@kit.edu>  Sun, 15 Nov 2020 21:27:45 +0100

webapi (3.0.0) stretch buster bullseye bookworm; urgency=medium

  * Integrate changes from Klara Mall <klara.mall@kit.edu>

 -- Andreas Ley <andreas.ley@kit.edu>  Sat, 14 Nov 2020 21:02:57 +0100

webapi (2.0.6) stretch buster bullseye bookworm; urgency=medium

  * CNAMES have changed from alias:0000 to alias:1000

 -- Andreas Ley <andreas.ley@kit.edu>  Thu, 16 Apr 2020 17:28:14 +0200

webapi (2.0) stretch buster bullseye bookworm; urgency=medium

  * Initial Release.

 -- Andreas Ley <andreas.ley@kit.edu>  Fri, 15 Mar 2019 19:34:23 +0100

=== debian/control ===
Source: webapi
Maintainer: Andreas Ley <andreas.ley@kit.edu>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.2
Homepage: http://andy.scc.kit.edu/source/Local/webapi-4.2.0/

Package: webapi
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${perl:Depends},
         libnetaddr-ip-perl,
         libjson-perl,
         libwww-perl,
         libhttp-message-perl
Description: Perl interface to KIT SCC NET WebAPI
 The network section (NET) of the Scientific Computing Center (SCC)
 at the Karlsruhe Institute of Technology (KIT) uses a custom Web API
 for managing Domain Name System (DNS) records. This is a perl
 library with convenience functions to handle the most common use
 cases using this API.
